

%%% Put an element X on the first position into list L

put_first(X,L,[X|L]) :- !.



%%% Put an element X on the last position into list L

put_last(X,[],[X]) :- !.
put_last(X,[F|L],[F|LX]) :- put_last(X,L,LX).

put_last_append(X,L,LX) :- append(L,[X],LX).



%%% Put an element X on the k-th position into list L
put_k(X,1,L,[X|L]):- !.
put_k(X,K,[F|L],[F|LX]):- K1 is K-1, put_k(X,K1,L,LX). 

put_k_append(X,K,L,FXE) :- append(F,E,L), K1 is K-1, length(F,K1), append(F,[X|E],FXE).


%%% Put an element X into  an ordered list L on its right position
put_in_order(X,[],[X]) :- !.
put_in_order(X,[F|L],[X,F|L]) :- X =< F, !.
put_in_order(X,[F|L],[F|XL]) :- X > F, put_in_order(X,L,XL).

% List generation: N..1

make_list_N_1(0,[]) :- !.
make_list_N_1(N,LN) :- N1 is N-1, make_list_N_1(N1,LN1), put_last(N,LN1,LN).

% Iteration make_list simplified
make_list_1_N(N,L) :-
   do(N,[],L).

do(1,A,[1|A]) :- !.
do(K,A,L) :-
  K1 is K-1,
  do(K1,[K|A],L).


writelist([]):- nl.
writelist([H|T]):-
       write(H),nl,
       writelist(T).

