
% solving quadratic equation ax^2 + bx + c = 0

run(A,B,C) :-
    Delta is B^2 - 4*A*C,
    case(A,B,C,Delta).

case(A,B,_,Delta) :- 
    Delta > 0,!,
    X1 is (-B - sqrt(Delta))/(2*A),  
    X2 is (-B + sqrt(Delta))/(2*A),
    write('X1 = '), write(X1),nl,
    write('X2 = '), write(X2).
case(A,B,_,Delta) :- 
    Delta =:= 0, !,
    X1 = -B/(2*A),
    write('X1 = X2 = '), write(X1).
case(_,_,_,Delta) :- 
    Delta < 0,
    write('No solution in real numbers'),nl,
    write('Delta = '), write(Delta).
